"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBProgramNode subclass:#TTypeSpecNode
	instanceVariableNames:'start stop type'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!

!TTypeSpecNode class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!TTypeSpecNode class methodsFor:'accessing'!

formatterClass
        ^FormatterClass isNil ifTrue: [TFormatter] ifFalse: [FormatterClass]

    "Created: / 21-08-2015 / 22:16:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TTypeSpecNode methodsFor:'accessing'!

start
    ^ start
!

start:anInteger
    start := anInteger.
!

stop
    ^ stop
!

stop:anInteger
    stop := anInteger.
!

type
    ^ type
!

type:aTTypeNode
    type := aTTypeNode.
! !

!TTypeSpecNode methodsFor:'converting'!

asType
    ^ type asType

    "Created: / 25-08-2015 / 22:47:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TTypeSpecNode methodsFor:'visitor'!

acceptVisitor: aProgramNodeVisitor 
    ^ aProgramNodeVisitor acceptTypeSpecNode: self

    "Created: / 21-08-2015 / 22:14:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

